diff -aruN --binary 18/administrator/components/com_menus/controller.php 20/administrator/components/com_menus/controller.php
--- 18/administrator/components/com_menus/controller.php	2010-04-23 13:40:10.000000000 +0200
+++ 20/administrator/components/com_menus/controller.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: controller.php 15095 2010-02-27 14:14:06Z ian $
+ * @version		$Id: controller.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Menus
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -93,12 +93,19 @@
 		$item =& $model->getItem();
 		switch ( $this->_task ) {
 			case 'apply':
-				$this->setRedirect( 'index.php?option=com_menus&menutype='.$item->menutype.'&task=edit&cid[]='.$item->id.'' , $msg );
+				$this->setRedirect( 
+					'index.php?option=com_menus&menutype=' . $item->menutype
+					. '&task=edit&cid[]=' . $item->id,
+					$msg
+				);
 				break;
 
 			case 'save':
 			default:
-				$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$item->menutype, $msg );
+				$this->setRedirect(
+					'index.php?option=com_menus&task=view&menutype=' . $item->menutype,
+					$msg
+				);
 				break;
 		}
 	}
@@ -112,12 +119,12 @@
 
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
-		$menutype = $mainframe->getUserStateFromRequest( 'com_menus.menutype', 'menutype', 'mainmenu', 'string' );
+		$menutype = $mainframe->getUserStateFromRequest( 'com_menus.menutype', 'menutype', 'mainmenu', 'menutype' );
 
 		$model = $this->getModel('item');
 		$model->checkin();
 
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menutype);
+		$this->setRedirect('index.php?option=com_menus&task=view&menutype=' . $menutype);
 	}
 
 	/**
@@ -150,7 +157,7 @@
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
 		// Get some variables from the request
-		$menu	 	= JRequest::getString( 'menu', '', 'post');
+		$menu       = JRequest::getVar('menu', '', 'post', 'menutype');
 		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
 		JArrayHelper::toInteger($cid);
 
@@ -169,7 +176,7 @@
 		} else {
 			$msg = $model->getError();
 		}
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, $msg );
+		$this->setRedirect('index.php?option=com_menus&task=view&menutype=' . $menu, $msg);
 	}
 
 	/**
@@ -194,7 +201,7 @@
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
 		// Get some variables from the request
-		$menu	= JRequest::getVar( 'menu', '', 'post', 'string' );
+		$menu	= JRequest::getVar( 'menu', '', 'post', 'menutype' );
 		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
 		JArrayHelper::toInteger($cid);
 
@@ -213,7 +220,7 @@
 		} else {
 			$msg = $model->getError();
 		}
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, $msg );
+		$this->setRedirect('index.php?option=com_menus&task=view&menutype=' . $menu, $msg);
 	}
 
 	/**
@@ -225,7 +232,7 @@
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
 		// Get some variables from the request
-		$menu	= JRequest::getVar( 'menutype', '', 'post', 'string' );
+		$menutype = JRequest::getVar('menutype', '', 'post', 'menutype');
 		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
 		JArrayHelper::toInteger($cid);
 
@@ -235,7 +242,7 @@
 		} else {
 			$msg = $model->getError();
 		}
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, $msg );
+		$this->setRedirect('index.php?option=com_menus&task=view&menutype=' . $menutype, $msg);
 	}
 
 	/**
@@ -247,7 +254,7 @@
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
 		// Get some variables from the request
-		$menu	= JRequest::getVar( 'menutype', '', 'post', 'string' );
+		$menutype = JRequest::getVar('menutype', '', 'post', 'menutype');
 		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
 		JArrayHelper::toInteger($cid);
 
@@ -257,7 +264,7 @@
 		} else {
 			$msg = $model->getError();
 		}
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, $msg );
+		$this->setRedirect('index.php?option=com_menus&task=view&menutype=' . $menutype, $msg);
 	}
 
 	/**
@@ -268,14 +275,17 @@
 		// Check for request forgeries
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
-		$menu	= JRequest::getVar( 'menutype', '', 'post', 'string' );
+		$menutype = JRequest::getVar('menutype', '', 'post', 'menutype');
 		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
 		JArrayHelper::toInteger($cid);
 
 		if (isset($cid[0]) && $cid[0]) {
 			$id = $cid[0];
 		} else {
-			$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, JText::_('No Items Selected') );
+			$this->setRedirect(
+				'index.php?option=com_menus&task=view&menutype=' . $menutype,
+				JText::_('No Items Selected')
+			);
 			return false;
 		}
 
@@ -285,7 +295,7 @@
 		} else {
 			$msg = $model->getError();
 		}
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, $msg );
+		$this->setRedirect('index.php?option=com_menus&task=view&menutype=' . $menutype, $msg);
 	}
 
 	/**
@@ -296,14 +306,17 @@
 		// Check for request forgeries
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
-		$menu	= JRequest::getVar( 'menutype', '', 'post', 'string' );
+		$menutype = JRequest::getVar('menutype', '', 'post', 'menutype');
 		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
 		JArrayHelper::toInteger($cid);
 
 		if (isset($cid[0]) && $cid[0]) {
 			$id = $cid[0];
 		} else {
-			$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, JText::_('No Items Selected') );
+			$this->setRedirect(
+				'index.php?option=com_menus&task=view&menutype=' . $menutype,
+				JText::_('No Items Selected')
+			);
 			return false;
 		}
 
@@ -313,7 +326,7 @@
 		} else {
 			$msg = $model->getError();
 		}
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, $msg );
+		$this->setRedirect('index.php?option=com_menus&task=view&menutype=' . $menutype, $msg);
 	}
 
 	/**
@@ -324,17 +337,17 @@
 		// Check for request forgeries
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
-		$menu	= JRequest::getVar( 'menutype', '', 'post', 'string' );
+		$menutype = JRequest::getVar('menutype', '', 'post', 'menutype');
 		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
 		JArrayHelper::toInteger($cid);
 
 		$model =& $this->getModel( 'List' );
-		if ($model->setOrder($cid, $menu)) {
+		if ($model->setOrder($cid, $menutype)) {
 			$msg = JText::_( 'New ordering saved' );
 		} else {
 			$msg = $model->getError();
 		}
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, $msg );
+		$this->setRedirect('index.php?option=com_menus&task=view&menutype='. $menutype, $msg);
 	}
 
 	/**
@@ -346,7 +359,7 @@
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
 		// Get some variables from the request
-		$menu	= JRequest::getVar( 'menutype', '', 'post', 'string' );
+		$menutype = JRequest::getVar('menutype', '', 'post', 'menutype');
 		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
 		JArrayHelper::toInteger($cid);
 
@@ -356,7 +369,7 @@
 		} else {
 			$msg = $model->getError();
 		}
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, $msg );
+		$this->setRedirect('index.php?option=com_menus&task=view&menutype=' . $menutype, $msg);
 	}
 
 	/**
@@ -368,7 +381,7 @@
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
 		// Get some variables from the request
-		$menu	= JRequest::getVar( 'menutype', '', 'post', 'string' );
+		$menutype	= JRequest::getVar('menutype', '', 'post', 'menutype');
 		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
 		JArrayHelper::toInteger($cid);
 
@@ -378,7 +391,7 @@
 		} else {
 			$msg = $model->getError();
 		}
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, $msg );
+		$this->setRedirect('index.php?option=com_menus&task=view&menutype=' . $menutype, $msg);
 	}
 
 	/**
@@ -390,7 +403,7 @@
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
 		// Get some variables from the request
-		$menu	= JRequest::getVar( 'menutype', '', 'post', 'string' );
+		$menutype = JRequest::getVar('menutype', '', 'post', 'menutype');
 		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
 		JArrayHelper::toInteger($cid);
 
@@ -400,7 +413,7 @@
 		} else {
 			$msg = $model->getError();
 		}
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, $msg );
+		$this->setRedirect('index.php?option=com_menus&task=view&menutype=' . $menutype, $msg);
 	}
 
 	/**
@@ -412,21 +425,27 @@
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
 		// Get some variables from the request
-		$menu	= JRequest::getVar( 'menutype', '', 'post', 'string' );
+		$menutype = JRequest::getVar('menutype', '', 'post', 'menutype');
 		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
 		JArrayHelper::toInteger($cid);
 
 		if (isset($cid[0]) && $cid[0]) {
 			$id = $cid[0];
 		} else {
-			$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, JText::_('No Items Selected') );
+			$this->setRedirect( 
+				'index.php?option=com_menus&task=view&menutype=' . $menutype,
+				JText::_('No Items Selected') 
+			);
 			return false;
 		}
 
 		$item =& JTable::getInstance( 'menu' );
 		$item->load($id);
 		if(!$item->get('published')) {
-			$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, JText::_('The Default Menu Item Must Be Published') );
+			$this->setRedirect(
+				'index.php?option=com_menus&task=view&menutype=' . $menutype,
+				JText::_('The Default Menu Item Must Be Published') 
+			);
 			return false;
 		}
 
@@ -436,7 +455,10 @@
 		} else {
 			$msg = $model->getError();
 		}
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, $msg );
+		$this->setRedirect(
+			'index.php?option=com_menus&task=view&menutype=' . $menutype,
+			$msg
+		);
 	}
 
 	function remove()
@@ -445,12 +467,15 @@
 		JRequest::checkToken() or jexit( 'Invalid Token' );
 
 		// Get some variables from the request
-		$menu	= JRequest::getVar( 'menutype', '', 'post', 'string' );
+		$menutype = JRequest::getVar('menutype', '', 'post', 'menutype');
 		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
 		JArrayHelper::toInteger($cid);
 
 		if (!count($cid)) {
-			$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, JText::_('No Items Selected') );
+			$this->setRedirect( 
+				'index.php?option=com_menus&task=view&menutype=' . $menutype,
+				JText::_('No Items Selected') 
+			);
 			return false;
 		}
 
@@ -460,7 +485,10 @@
 		} else {
 			$msg = $model->getError();
 		}
-		$this->setRedirect( 'index.php?option=com_menus&task=view&menutype='.$menu, $msg );
+		$this->setRedirect( 
+			'index.php?option=com_menus&task=view&menutype=' . $menutype,
+			$msg
+		);
 	}
 
 	/**
@@ -693,7 +721,7 @@
 
 		$db				=& JFactory::getDBO();
 		$type			= JRequest::getVar( 'type', '', 'post', 'string' );
-		$menu_name		= JRequest::getVar( 'menu_name', 'New Menu', 'post', 'string' );
+		$menu_name		= JRequest::getVar( 'menu_name', 'New Menu', 'post', 'menutype' );
 		$module_name	= JRequest::getVar( 'module_name', 'New Module', 'post', 'string' );
 
 		// check for unique menutype for new menu copy
diff -aruN --binary 18/administrator/components/com_menus/models/item.php 20/administrator/components/com_menus/models/item.php
--- 18/administrator/components/com_menus/models/item.php	2010-04-23 13:40:10.000000000 +0200
+++ 20/administrator/components/com_menus/models/item.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: item.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: item.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Menus
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -92,8 +92,8 @@
 		}
 
 		// Override the current item's menutype field if defined in the request
-		if ($menu_type = JRequest::getString('menutype')) {
-			$table->menutype = $menu_type;
+		if ($menutype = JRequest::getVar('menutype', '', '', 'menutype')) {
+			$table->menutype = $menutype;
 		}
 
 		switch ($table->type)
@@ -144,7 +144,7 @@
 	{
 		$item				= &$this->getItem();
 		$return['option']	= JRequest::getCmd('expand');
-		$menutype			= JRequest::getString('menutype');
+		$menutype			= JRequest::getVar('menutype', '', '', 'menutype');
 
 		if ($return['option'])
 		{
diff -aruN --binary 18/administrator/components/com_menus/models/list.php 20/administrator/components/com_menus/models/list.php
--- 18/administrator/components/com_menus/models/list.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_menus/models/list.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: list.php 17299 2010-05-27 16:06:54Z ian $
+ * @version		$Id: list.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Menus
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -53,7 +53,7 @@
 
 		$db =& $this->getDBO();
 
-		$menutype			= $mainframe->getUserStateFromRequest( "com_menus.menutype",						'menutype',			'mainmenu',		'string' );
+		$menutype			= $mainframe->getUserStateFromRequest( 'com_menus.menutype',						'menutype',			'mainmenu',		'menutype' );
 		$filter_order		= $mainframe->getUserStateFromRequest( 'com_menus.'.$menutype.'.filter_order',		'filter_order',		'm.ordering',	'cmd' );
 		$filter_order_Dir	= $mainframe->getUserStateFromRequest( 'com_menus.'.$menutype.'.filter_order_Dir',	'filter_order_Dir',	'ASC',			'word' );
 		$filter_state		= $mainframe->getUserStateFromRequest( 'com_menus.'.$menutype.'.filter_state',		'filter_state',		'',				'word' );
@@ -76,6 +76,11 @@
 			}
 		}
 
+		// ensure $filter_order has a good value
+		if (!in_array($filter_order, array('m.name', 'm.published', 'm.ordering', 'groupname', 'm.type', 'm.id'))) {
+			$filter_order = 'm.ordering';
+		}
+
 		// just in case filter_order get's messed up
 		if ($filter_order) {
 			$orderby = ' ORDER BY '.$filter_order .' '. $filter_order_Dir .', m.parent, m.ordering';
diff -aruN --binary 18/administrator/components/com_menus/models/menutype.php 20/administrator/components/com_menus/models/menutype.php
--- 18/administrator/components/com_menus/models/menutype.php	2010-04-23 13:40:10.000000000 +0200
+++ 20/administrator/components/com_menus/models/menutype.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: menutype.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: menutype.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Menus
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -146,7 +146,7 @@
 	{
 		$table = & $this->getTable();
 		if ($table->menutype == '') {
-			$table->menutype = JRequest::getString('menutype');
+			$table->menutype = JRequest::getVar('menutype', '', '', 'menutype');
 		}
 
 		$db = &$this->getDBO();
diff -aruN --binary 18/administrator/components/com_menus/views/item/tmpl/form.php 20/administrator/components/com_menus/views/item/tmpl/form.php
--- 18/administrator/components/com_menus/views/item/tmpl/form.php	2009-11-04 19:51:18.000000000 +0100
+++ 20/administrator/components/com_menus/views/item/tmpl/form.php	2010-07-18 05:15:44.000000000 +0200
@@ -56,7 +56,7 @@
 						<?php echo JText::_( 'Menu Item Type' ); ?>
 					</legend>
 					<div style="float:right">
-						<button type="button" onclick="location.href='index.php?option=com_menus&amp;task=type&amp;menutype=<?php echo $this->item->menutype;?><?php echo $this->item->expansion; ?>&amp;cid[]=<?php echo $this->item->id; ?>';">
+						<button type="button" onclick="location.href='index.php?option=com_menus&amp;task=type&amp;menutype=<?php echo htmlspecialchars($this->item->menutype);?><?php echo $this->item->expansion; ?>&amp;cid[]=<?php echo $this->item->id; ?>';">
 							<?php echo JText::_( 'Change Type' ); ?></button>
 					</div>
 					<h2><?php echo $this->name; ?></h2>
diff -aruN --binary 18/administrator/components/com_menus/views/item/tmpl/type.php 20/administrator/components/com_menus/views/item/tmpl/type.php
--- 18/administrator/components/com_menus/views/item/tmpl/type.php	2009-05-29 14:50:56.000000000 +0200
+++ 20/administrator/components/com_menus/views/item/tmpl/type.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,4 +1,11 @@
-<?php defined('_JEXEC') or die('Restricted access'); ?>
+<?php
+defined('_JEXEC') or die('Restricted access'); 
+
+// Precompute the menu type and CID
+$typeCid = '&amp;menutype=' . htmlspecialchars($this->item->menutype) 
+	. '&amp;cid[]=' . $this->item->id
+;
+?>
 
 <script language="javascript" type="text/javascript">
 	<!--
@@ -19,20 +26,20 @@
 							<ul>
 								<?php for ($i=0,$n=count($this->components);$i<$n;$i++) : ?>
 									<?php if($this->components[$i]->legacy) : ?>
-										<li><div class="node-open"><span></span><a href="index.php?option=com_menus&amp;task=edit&amp;type=component&amp;url[option]=<?php echo $this->components[$i]->option; ?>&amp;menutype=<?php echo $this->item->menutype; ?>&amp;cid[]=<?php echo $this->item->id; ?>" id="<?php echo str_replace('com_', '', $this->components[$i]->option); ?>"><?php echo $this->components[$i]->name; ?></a></div>
+										<li><div class="node-open"><span></span><a href="index.php?option=com_menus&amp;task=edit&amp;type=component&amp;url[option]=<?php echo $this->components[$i]->option . $typeCid; ?>" id="<?php echo str_replace('com_', '', $this->components[$i]->option); ?>"><?php echo $this->components[$i]->name; ?></a></div>
 									<?php elseif ($this->expansion['option'] == str_replace('com_', '', $this->components[$i]->option)) : ?>
 										<li <?php echo ($i == $n-1)? 'class="last"' : '' ?>><div class="node-open"><span></span><a id="<?php echo str_replace('com_', '', $this->components[$i]->option); ?>"><?php echo JText::_($this->components[$i]->name); ?></a></div>
 										<?php echo $this->expansion['html']; ?>
 									<?php else : ?>
-										<li <?php echo ($i == $n-1)? 'class="last"' : '' ?>><div class="node"><span></span><a href="index.php?option=com_menus&amp;task=type&amp;menutype=<?php echo $this->item->menutype; ?>&amp;cid[]=<?php echo $this->item->id; ?>&amp;expand=<?php echo str_replace('com_', '', $this->components[$i]->option); ?>" id="<?php echo str_replace('com_', '', $this->components[$i]->option); ?>"><?php echo JText::_($this->components[$i]->name); ?></a></div>
+										<li <?php echo ($i == $n-1)? 'class="last"' : '' ?>><div class="node"><span></span><a href="index.php?option=com_menus&amp;task=type<?php echo $typeCid; ?>&amp;expand=<?php echo str_replace('com_', '', $this->components[$i]->option); ?>" id="<?php echo str_replace('com_', '', $this->components[$i]->option); ?>"><?php echo JText::_($this->components[$i]->name); ?></a></div>
 									<?php endif; ?>
 								</li>
 								<?php endfor; ?>
 							</ul>
 						</li>
-						<li id="external-node"><div class="base"><span></span><a href="index.php?option=com_menus&amp;task=edit&amp;type=url&amp;menutype=<?php echo $this->item->menutype; ?>&amp;cid[]=<?php echo $this->item->id; ?>"><?php echo JText::_('External Link'); ?></a></div></li>
-						<li id="separator-node"><div class="base"><span></span><a href="index.php?option=com_menus&amp;task=edit&amp;type=separator&amp;menutype=<?php echo $this->item->menutype; ?>&amp;cid[]=<?php echo $this->item->id; ?>"><?php echo JText::_('Separator'); ?></a></div></li>
-						<li id="link-node" class="last"><div class="base"><span></span><a href="index.php?option=com_menus&amp;task=edit&amp;type=menulink&amp;menutype=<?php echo $this->item->menutype; ?>&amp;cid[]=<?php echo $this->item->id; ?>"><?php echo JText::_('Alias'); ?></a></div></li>
+						<li id="external-node"><div class="base"><span></span><a href="index.php?option=com_menus&amp;task=edit&amp;type=url<?php echo $typeCid; ?>"><?php echo JText::_('External Link'); ?></a></div></li>
+						<li id="separator-node"><div class="base"><span></span><a href="index.php?option=com_menus&amp;task=edit&amp;type=separator<?php echo $typeCid; ?>"><?php echo JText::_('Separator'); ?></a></div></li>
+						<li id="link-node" class="last"><div class="base"><span></span><a href="index.php?option=com_menus&amp;task=edit&amp;type=menulink<?php echo $typeCid; ?>"><?php echo JText::_('Alias'); ?></a></div></li>
 					</ul>
 				</fieldset>
 			</td>
diff -aruN --binary 18/administrator/components/com_menus/views/list/tmpl/copy.php 20/administrator/components/com_menus/views/list/tmpl/copy.php
--- 18/administrator/components/com_menus/views/list/tmpl/copy.php	2009-05-29 14:50:56.000000000 +0200
+++ 20/administrator/components/com_menus/views/list/tmpl/copy.php	2010-07-18 05:15:44.000000000 +0200
@@ -41,7 +41,7 @@
 
 	<input type="hidden" name="option" value="com_menus" />
 	<input type="hidden" name="boxchecked" value="0" />
-	<input type="hidden" name="menutype" value="<?php echo $this->menutype; ?>" />
+	<input type="hidden" name="menutype" value="<?php echo htmlspecialchars($this->menutype); ?>" />
 	<input type="hidden" name="task" value="" />
 <?php foreach ( $this->items as $item ) : ?>
 	<input type="hidden" name="cid[]" value="<?php echo $item->id; ?>" />
diff -aruN --binary 18/administrator/components/com_menus/views/list/tmpl/default.php 20/administrator/components/com_menus/views/list/tmpl/default.php
--- 18/administrator/components/com_menus/views/list/tmpl/default.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_menus/views/list/tmpl/default.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php defined('_JEXEC') or die('Restricted access'); ?>
 
-<form action="index.php?option=com_menus&amp;menutype=<?php echo $this->menutype; ?>" method="post" name="adminForm">
+<form action="index.php?option=com_menus&amp;menutype=<?php echo htmlspecialchars($this->menutype); ?>" method="post" name="adminForm">
 
 	<table>
 		<tr>
@@ -83,7 +83,7 @@
 				<?php echo $row->treename; ?>
 				<?php else : ?>
 				<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Menu' );?>::<?php echo $row->treename; ?>">
-				<a href="<?php echo JRoute::_( 'index.php?option=com_menus&menutype='.$row->menutype.'&task=edit&cid[]='.$row->id ); ?>"><?php echo $row->treename; ?></a></span>
+				<a href="<?php echo JRoute::_('index.php?option=com_menus&menutype=' . htmlspecialchars($row->menutype) . '&task=edit&cid[]=' . $row->id); ?>"><?php echo $row->treename; ?></a></span>
 				<?php endif; ?>
 			</td>
 			<td align="center">
@@ -121,7 +121,7 @@
 	</table>
 
 	<input type="hidden" name="option" value="com_menus" />
-	<input type="hidden" name="menutype" value="<?php echo $this->menutype; ?>" />
+	<input type="hidden" name="menutype" value="<?php echo htmlspecialchars($this->menutype); ?>" />
 	<input type="hidden" name="task" value="view" />
 	<input type="hidden" name="boxchecked" value="0" />
 	<input type="hidden" name="filter_order" value="<?php echo $this->lists['order']; ?>" />
diff -aruN --binary 18/administrator/components/com_menus/views/list/tmpl/move.php 20/administrator/components/com_menus/views/list/tmpl/move.php
--- 18/administrator/components/com_menus/views/list/tmpl/move.php	2009-05-29 14:50:56.000000000 +0200
+++ 20/administrator/components/com_menus/views/list/tmpl/move.php	2010-07-18 05:15:44.000000000 +0200
@@ -44,7 +44,7 @@
 	<input type="hidden" name="option" value="com_menus" />
 	<input type="hidden" name="boxchecked" value="1" />
 	<input type="hidden" name="task" value="" />
-	<input type="hidden" name="menutype" value="<?php echo $this->menutype; ?>" />
+	<input type="hidden" name="menutype" value="<?php echo htmlspecialchars($this->menutype); ?>" />
 <?php foreach ( $this->items as $item ) : ?>
 	<input type="hidden" name="cid[]" value="<?php echo $item->id; ?>" />
 <?php endforeach; ?>
diff -aruN --binary 18/administrator/components/com_menus/views/list/view.php 20/administrator/components/com_menus/views/list/view.php
--- 18/administrator/components/com_menus/views/list/view.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_menus/views/list/view.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: view.php 17299 2010-05-27 16:06:54Z ian $
+ * @version		$Id: view.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Menus
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -35,7 +35,7 @@
 		/*
 		 * Set toolbar items for the page
 		 */
-		$menutype 	= $mainframe->getUserStateFromRequest( 'com_menus.menutype', 'menutype', 'mainmenu', 'string' );
+		$menutype 	= $mainframe->getUserStateFromRequest('com_menus.menutype', 'menutype', 'mainmenu', 'menutype');
 
 		JToolBarHelper::title( JText::_( 'MENU ITEM MANAGER' ) .': <small><small>['.$menutype.']</small></small>', 'menu.png' );
 
@@ -102,7 +102,7 @@
 		$document = & JFactory::getDocument();
 		$document->setTitle(JText::_('Copy Menu Items'));
 
-		$menutype 	= $mainframe->getUserStateFromRequest( 'com_menus.menutype', 'menutype', 'mainmenu', 'string' );
+		$menutype 	= $mainframe->getUserStateFromRequest('com_menus.menutype', 'menutype', 'mainmenu', 'menutype');
 
 		// Build the menutypes select list
 		$menuTypes 	= MenusHelper::getMenuTypes();
@@ -138,7 +138,7 @@
 		$document = & JFactory::getDocument();
 		$document->setTitle(JText::_('Move Menu Items'));
 
-		$menutype 	= $mainframe->getUserStateFromRequest( 'com_menus.menutype', 'menutype', 'mainmenu', 'string' );
+		$menutype 	= $mainframe->getUserStateFromRequest('com_menus.menutype', 'menutype', 'mainmenu', 'menutype');
 
 		// Build the menutypes select list
 		$menuTypes 	= MenusHelper::getMenuTypes();
@@ -162,7 +162,7 @@
 		global $mainframe;
 		$db		=& JFactory::getDBO();
 
-		$menutype			= $mainframe->getUserStateFromRequest( "com_menus.menutype",					'menutype',			'mainmenu',		'string' );
+		$menutype			= $mainframe->getUserStateFromRequest( 'com_menus.menutype',					'menutype',			'mainmenu',		'menutype' );
 		$filter_order		= $mainframe->getUserStateFromRequest( "com_menus.$menutype.filter_order",		'filter_order',		'm.ordering',	'cmd' );
 		$filter_order_Dir	= $mainframe->getUserStateFromRequest( "com_menus.$menutype.filter_order_Dir",	'filter_order_Dir',	'ASC',			'word' );
 		$filter_state		= $mainframe->getUserStateFromRequest( "com_menus.$menutype.filter_state",		'filter_state',		'',				'word' );
@@ -173,6 +173,11 @@
 		}
 		$search = JString::strtolower($search);
 
+		// ensure $filter_order has a good value
+		if (!in_array($filter_order, array('m.name', 'm.published', 'm.ordering', 'groupname', 'm.type', 'm.id'))) {
+			$filter_order = 'm.ordering';
+		}
+
 		// level limit filter
 		$lists['levellist'] = JHTML::_('select.integerlist',    1, 20, 1, 'levellimit', 'size="1" onchange="document.adminForm.submit();"', $levellimit );
 
diff -aruN --binary 18/administrator/components/com_menus/views/menus/tmpl/copy.php 20/administrator/components/com_menus/views/menus/tmpl/copy.php
--- 18/administrator/components/com_menus/views/menus/tmpl/copy.php	2009-05-29 14:50:54.000000000 +0200
+++ 20/administrator/components/com_menus/views/menus/tmpl/copy.php	2010-07-18 05:15:44.000000000 +0200
@@ -58,6 +58,6 @@
 
 	<input type="hidden" name="option" value="com_menus" />
 	<input type="hidden" name="task" value="" />
-	<input type="hidden" name="type" value="<?php echo $this->table->menutype; ?>" />
+	<input type="hidden" name="type" value="<?php echo htmlspecialchars($this->table->menutype); ?>" />
 	<?php echo JHTML::_( 'form.token' ); ?>
 </form>
\ No hay ningún carácter de nueva línea al final del fichero
diff -aruN --binary 18/administrator/components/com_menus/views/menus/tmpl/default.php 20/administrator/components/com_menus/views/menus/tmpl/default.php
--- 18/administrator/components/com_menus/views/menus/tmpl/default.php	2009-05-29 14:50:54.000000000 +0200
+++ 20/administrator/components/com_menus/views/menus/tmpl/default.php	2010-07-18 05:15:44.000000000 +0200
@@ -76,7 +76,7 @@
 		<?php
 			// Get the current iteration and set a few values
 			$link 	= 'index.php?option=com_menus&amp;task=editMenu&amp;id='. $menu->id;
-			$linkA 	= 'index.php?option=com_menus&amp;task=view&amp;menutype='. $menu->menutype;
+			$linkA 	= 'index.php?option=com_menus&amp;task=view&amp;menutype='. htmlspecialchars($menu->menutype);
 		?>
 		<tr class="<?php echo "row". $k; ?>">
 			<td align="center" width="30">
@@ -86,12 +86,12 @@
 				<input type="radio" id="cb<?php echo $i;?>" name="id" value="<?php echo $menu->id; ?>" onclick="isChecked(this.checked);" />
 			</td>
 			<td>
-			<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Menu Name' );?>::<?php echo $menu->title; ?>">
+			<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Menu Name' );?>::<?php echo htmlspecialchars($menu->title); ?>">
 				<a href="<?php echo $link; ?>">
-					<?php echo $menu->title; ?></a></span>
+					<?php echo htmlspecialchars($menu->title); ?></a></span>
 			</td>
 			<td>
-				<?php echo $menu->menutype; ?>
+				<?php echo htmlspecialchars($menu->menutype); ?>
 			</td>
 			<td align="center">
 				<a href="<?php echo $linkA; ?>" title="<?php echo JText::_( 'Edit Menu Items' ); ?>">
diff -aruN --binary 18/administrator/components/com_menus/views/menus/tmpl/edit.php 20/administrator/components/com_menus/views/menus/tmpl/edit.php
--- 18/administrator/components/com_menus/views/menus/tmpl/edit.php	2009-05-29 14:50:54.000000000 +0200
+++ 20/administrator/components/com_menus/views/menus/tmpl/edit.php	2010-07-18 05:15:44.000000000 +0200
@@ -41,7 +41,7 @@
 			</label>
 		</td>
 		<td>
-			<input class="inputbox" type="text" name="menutype" id="menutype" size="30" maxlength="25" value="<?php echo $this->row->menutype; ?>" />			<?php echo JHTML::_('tooltip', JText::_( 'TIPNAMEUSEDTOIDENTIFYMENU' )); ?>
+			<input class="inputbox" type="text" name="menutype" id="menutype" size="30" maxlength="25" value="<?php echo htmlspecialchars($this->row->menutype); ?>" />			<?php echo JHTML::_('tooltip', JText::_( 'TIPNAMEUSEDTOIDENTIFYMENU' )); ?>
 		</td>
 	</tr>
 	<tr>
@@ -51,7 +51,7 @@
 			</label>
 		</td>
 		<td>
-			<input class="inputbox" type="text" name="title" id="title" size="30" maxlength="255" value="<?php echo $this->row->title; ?>" />
+			<input class="inputbox" type="text" name="title" id="title" size="30" maxlength="255" value="<?php echo $this->escape($this->row->title); ?>" />
 			<?php echo JHTML::_('tooltip',  JText::_( 'A proper title for the Menu' ) ); ?>
 		</td>
 	</tr>
@@ -62,7 +62,7 @@
 			</label>
 		</td>
 		<td>
-			<input class="inputbox" type="text" name="description" id="description" size="30" maxlength="255" value="<?php echo $this->row->description; ?>" />
+			<input class="inputbox" type="text" name="description" id="description" size="30" maxlength="255" value="<?php echo $this->escape($this->row->description); ?>" />
 			<?php echo JHTML::_('tooltip',  JText::_( 'A description for the Menu' ) ); ?>
 		</td>
 	</tr>
